declare name "DPSpec (multichannel)";
declare author "Alex Chechile";
declare version "The Ear Tone Toolbox v.1.01";
declare copyright "Copyright 2016 Alex Chechile (chechile@ccrma.stanford.edu)";
declare license "GNU GPL (see COPYING.txt)";
declare description "This is the constrained version of DPSpec to help keep the primary tones in proper ratio for producing robust DTs";

import("music.lib");
import("filter.lib");

f0 = hslider("f0",100,1,1150,0.0001); // f0 is the quadratic difference tone f2-f1 value
f1 = hslider("f1",1000,1,7000,0.0001); // f1 is the first primary tone

// primary tone spectrum
f2 = f0 + f1;
f3 = 2 * f0 + f1;
f4 = 3 * f0 + f1;
f5 = 4 * f0 + f1;
f6 = 5 * f0 + f1;
f7 = 6 * f0 + f1;
f8 = 7 * f0 + f1;
f9 = 8 * f0 + f1;
f10 = 9 * f0 + f1;
f11 = 10 * f0 + f1;
f12 = 11 * f0 + f1;

// optional sanity check
SC1 = f2 - f1; // QDT
SC2 = f3 - f1;
SC3 = f4 - f1;
SC4 = f5 - f1;

// Limit for f2/f1 ratio to stay between 1.0002 and 1.98
fLimit = (((f2/f1)>1.0002) & ((f2/f1)<1.98)) : smooth(0.999);

// for multichannel output and/or for individual component processing
process = osc(f1) * fLimit,osc(f2)* fLimit,osc(f3)* fLimit,osc(f4)* fLimit,osc(f5)* fLimit,osc(f6)* fLimit,osc(f7)* fLimit,osc(f8)* fLimit,osc(f9)* fLimit,osc(f10)* fLimit,osc(f11)* fLimit,osc(f12)* fLimit,osc(SC1),osc(SC2),osc(SC3),osc(SC4);


