declare name "DPSpec_unlim (multichannel)";
declare author "Alex Chechile";
declare version "The Ear Tone Toolbox v.1.01";
declare copyright "Copyright 2016 Alex Chechile (chechile@ccrma.stanford.edu)";
declare license "GNU GPL (see COPYING.txt)";
declare description "This is the unconstrained version of DPSpec, but the f2/f1 ratio may exceed usable range for producing audible DTs";

import("music.lib");

f0 = hslider("f0",100,1,1150,0.0001); // f0 is the quadratic difference tone f2-f1 value
f1 = hslider("f1",1000,1,7000,0.0001); // f1 is the first primary tone

// primary tone spectrum
f2 = f0 + f1;
f3 = 2 * f0 + f1;
f4 = 3 * f0 + f1;
f5 = 4 * f0 + f1;
f6 = 5 * f0 + f1;
f7 = 6 * f0 + f1;
f8 = 7 * f0 + f1;
f9 = 8 * f0 + f1;
f10 = 9 * f0 + f1;
f11 = 10 * f0 + f1;
f12 = 11 * f0 + f1;

// optional sanity check
SC1 = f2 - f1; // QDT
SC2 = f3 - f1;
SC3 = f4 - f1;
SC4 = f5 - f1;

// for multichannel output and/or for individual component processing
process = osc(f1),osc(f2),osc(f3),osc(f4),osc(f5),osc(f6),osc(f7),osc(f8),osc(f9),osc(f10),osc(f11),osc(f12),osc(SC1),osc(SC2),osc(SC3),osc(SC4);


