declare name "DiffTone";
declare author "Alex Chechile";
declare version "The Ear Tone Toolbox v.1.01";
declare copyright "Copyright 2016 Alex Chechile (chechile@ccrma.stanford.edu)";
declare license "GNU GPL (see COPYING.txt)";
declare description "DiffTone generates f1 and f2 primary tones from the user defined QDT and CDT";

import("music.lib");

// input parameters 
QDT = hslider("QDT",440,25,3000,0.0001);
CDT = hslider("CDT",1200,55,2100,0.0001);

// primary tones from QDT and CDT values
f1 = CDT + QDT;
f2 = f1 + QDT;

// primary tones
Chan1 = osc(f1);
Chan2 = osc(f2);

// optional sanity check
Chan3 = osc(f2-f1); // QDT
Chan4 = osc((2*f1)-f2); // CDT

process = Chan1,Chan2,Chan3,Chan4;

