declare name "f1ratio";
declare author "Alex Chechile";
declare version "The Ear Tone Toolbox v.1.01";
declare copyright "Copyright 2016 Alex Chechile (chechile@ccrma.stanford.edu)";
declare license "GNU GPL (see COPYING.txt)";
declare description "f1ratio provides the user control over the f2/f1 primary tone ratio for producing QDT and CDT";

import("music.lib");

// input parameters
f1 = hslider("f1",1000,1,5000,0.0001);
ratio = hslider("ratio",1.22,1.009,1.98,0.0001);

// f2 calculated from f1 and ratio
f2 = f1*ratio;

// calculate the QDT and CDT
QDT = f2-f1;
CDT = (2*f1)-f2;

// primary tones
Chan1 = osc(f1);
Chan2 = osc(f2);

// optional sanity check
Chan3 = osc(QDT);
Chan4 = osc(CDT);

process = Chan1,Chan2,Chan3,Chan4;


