declare name "DiffTone_effect";
declare author "Alex Chechile";
declare version "The Ear Tone Toolbox v.1.01";
declare copyright "Copyright 2016 Alex Chechile (chechile@ccrma.stanford.edu)";
declare license "GNU GPL (see COPYING.txt)";
declare description "DiffTone generates f1 and f2 primary tones from the user defined QDT and CDT";

import("music.lib");
import("filter.lib");

QDT = hslider("QDT",440,1,3500,0.0001) : smooth(0.999);
CDT = hslider("CDT",1200,1,3500,0.0001) : smooth(0.999);
F1 = CDT + QDT;
F2 = F1 + QDT;
gain = hslider("gain",0,0,1,0.0001) : smooth(0.999);

Chan1 = osc(F1);
Chan2 = osc(F2);

process = ((Chan1+_)*gain),((Chan2+_)*gain);
