declare name "f1half_unlim_effect";
declare author "Alex Chechile";
declare version "The Ear Tone Toolbox v.1.01";
declare copyright "Copyright 2016 Alex Chechile (chechile@ccrma.stanford.edu)";
declare license "GNU GPL (see COPYING.txt)";
declare description "This is the unconstrained version of f1half, but the f2/f1 ratio may exceed usable range for producing QDT and CDT.";

import("music.lib");
import("math.lib");
import("filter.lib");

// input parameters 
QDT = hslider("QDT",1,1,15000,0.0001) : smooth(0.5);
CDT = hslider("CDT",1,1,15000,0.0001) : smooth(0.5);
f1 = hslider("f1",1,1,20000,0.0001) : smooth(0.5);

// generate f2 with f1 and either the QDT value or the CDT value.  The opposite value must be 1 to work.
//abs value to keep positive
f2 = fabs(((QDT+f1)*((QDT>1) & (CDT == 1))) + (((2*f1)-CDT)*((CDT>1) & (QDT == 1))));

// shut off oscillator if f2 is 0
fLimit = (f2!=0) : smooth(0.999);

gain = hslider("gain",0,0,1,0.0001) : smooth(0.999);

// primary tones
Chan1 = osc(f1);
Chan2 = osc(f2) * fLimit;

process = ((Chan1+_) * gain),((Chan2+_) * gain);