declare name "f1ratio_effect";
declare author "Alex Chechile";
declare version "The Ear Tone Toolbox v.1.01";
declare copyright "Copyright 2016 Alex Chechile (chechile@ccrma.stanford.edu)";
declare license "GNU GPL (see COPYING.txt)";
declare description "f1ratio provides the user control over the f2/f1 primary tone ratio for producing QDT and CDT";

import("music.lib");
import("filter.lib");

// input parameters
f1 = hslider("f1",1000,1,5000,0.0001) : smooth(0.999);
ratio = hslider("ratio",1.22,1.009,1.98,0.0001) : smooth(0.999);

// f2 calculated from f1 and ratio
f2 = f1*ratio;

gain = hslider("gain",0,0,1,0.0001) : smooth(0.999);

// primary tones
Chan1 = osc(f1);
Chan2 = osc(f2);

process = ((Chan1+_) * gain),((Chan2+_) * gain);
