declare name "DiffTone_QDT_Poly_ins";
declare author "Alex Chechile";
declare version "The Ear Tone Toolbox v.1.01";
declare copyright "Copyright 2016 Alex Chechile (chechile@ccrma.stanford.edu)";
declare license "GNU GPL (see COPYING.txt)";
declare description "DiffTone_QDT_Poly_ins uses polyphonic MIDI input to evoke the pitch as a QDT.  The CDT is a user defined parameter.";

import("music.lib");

freq = hslider("freq",440,1,3500,0.0001);  // freq is the QDT value, and the pitch of the MIDI note freq
gain = hslider("gain",1,0,1,0.0001);
gate = button("gate");

CDT = hslider("CDT",1200,1,3500,0.0001); // the CDT is user specified

f1 = CDT + freq;
f2 = f1 + freq;

// ADSR envelope parameters
attack  = hslider("attack", 0.02,0.01, 1, 0.001); // sec
decay   = hslider("decay",  0.3, 0, 1, 0.001); // sec
sustain = hslider("sustain",0.5, 0, 1, 0.01);  // frac
release = hslider("release",0.2, 0.01, 1, 0.001); // sec

env = gate : adsr(attack,decay,sustain,release);

process = ((osc(f1)/3)*env*gain), ((osc(f2)/3)*env*gain); // dividing each signal by 3 to prevent channel overload from polyphony