declare name "f1ratio_Mono_ins";
declare author "Alex Chechile";
declare version "The Ear Tone Toolbox v.1.01";
declare copyright "Copyright 2016 Alex Chechile (chechile@ccrma.stanford.edu)";
declare license "GNU GPL (see COPYING.txt)";
declare description "f1ratio_Mono_ins (monophonic) provides the user control over the f2/f1 primary tone ratio for producing QDT and CDT. The MIDI input device produces f1 and the ratio is a user defined parameter.";

import("music.lib");

// input parameters
freq = hslider("freq",1000,1,5000,0.0001);  // freq is the f1 value, and the pitch of the MIDI note freq
gain = hslider("gain",1,0,1,0.0001);
gate = button("gate");

ratio = hslider("ratio",1.22,1.009,1.98,0.0001);

// f2 calculated from f1 and ratio
f2 = freq*ratio;

// ADSR envelope parameters
attack  = hslider("attack", 0.02,0.01, 1, 0.001); // sec
decay   = hslider("decay",  0.3, 0, 1, 0.001); // sec
sustain = hslider("sustain",0.5, 0, 1, 0.01);  // frac
release = hslider("release",0.2, 0.01, 1, 0.001); // sec

env = gate : adsr(attack,decay,sustain,release);

process = (osc(freq)*env*gain), (osc(f2)*env*gain);